searchNodes=[{"doc":"Dead-letter message produced when evaluating of raw-topic failed.","ref":"Toolbox.ErrorMessage.html","title":"Toolbox.ErrorMessage","type":"module"},{"doc":"","ref":"Toolbox.ErrorMessage.html#t:t/0","title":"Toolbox.ErrorMessage.t/0","type":"type"},{"doc":"Dead-letter message produced when evaluating of raw-topic failed.","ref":"Toolbox.IgnoredMessage.html","title":"Toolbox.IgnoredMessage","type":"module"},{"doc":"","ref":"Toolbox.IgnoredMessage.html#t:t/0","title":"Toolbox.IgnoredMessage.t/0","type":"type"},{"doc":"Module extends Toolbox.Workflow and abstracts how regular incident behaves. Wraps around Toolbox.Workflow and adds some additional callbacks to manage incident in asset map. This module works very much like regular workflow, but some additional properties can be specified. Contrary to a regular workflow, this automatically generates OAs to manage the incident in asset map and therefore syncs the general state of this workflow with the incident asset. Start by creating a definition (see new/0 , add_transition/2 and build/1 ) which describes the workflow of the incident. Then, you can create a new instance based on that definition with new_instance/6 .","ref":"Toolbox.Incident.html","title":"Toolbox.Incident","type":"module"},{"doc":"Adds a new transition to incident workflow definition. Incident workflow transition can be defined by: from (source status) to (target status) when (predicate used to select transition which will be executed) there can be multiple when definitions in list, all definitions are connected with &amp;&amp; relation possible when definitions: {Module, function} , where function accepts transition, instance and message as args, returns boolean {:timeout, timeout} , where timeout is defined in milliseconds (transition is then automatically executed when time elapses the specified value) {:=, [path, to, state, key], value} (transition is executed if the specified field of state reaches the specified value) then (callback used to update workflow instance state during transition execution) there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where function accepts transition, instance and message as args, and returns {:ok, state()} to update the instance state side_effects (callback used to generate output actions during transition execution) there can be multiple definitions in list, all definitions are executed in given order possible definitions: {Module, function} , where function accepts transition, instance and message as args, and returns {:ok, [OA | Msg | OtherSideEffect]} update_history_entry (callback used to modify transition execution history entry stored in asset map) there can be multiple definitions in list, all definitions are executed in given order this is usually used to interpolate description texts, or to add additional attributes to history possible definitions: {Module, function} , where function accepts history entry, transition, instance and message as args and returns {:ok, history_entry} update_possible_transition (callback used to modify possible future transitions stored in asset map) there can be multiple definitions in list, all definitions are executed in given order the callback is executed for each possible future transition note this only modifies the items of future attribute of the incident asset, this has no effect on definition transitions possible definitions: {Module, function} , where function accepts possible transition, transition, instance and message as args, and returns {:ok, future_transition} user_actions (specifies all possible user actions from the target state) a map of user actions that should be enabled once the transition is executed and incident is in the target state user actions are automatically deleted if not present in the next transition keys are strings values are {module, function} , this specifies the function to be called to generate the user action token (since tokens are not known in advance, they are generated by the specified function) the function takes transition, instance, message as arguments and is expected to return {:ok, binary_token} to register the user action token upsert_attributes (specifies additional attributes to be added to the incident asset) list of callbacks to compute the additional attributes each callback produces a map of additional attributes and this is merged into a single map where the latter has priority over the former attributes cannot override attributes handled by this workflow incl. user actions, only other attributes can be added possible definitions: {Module, function} , where function accepts transition, instance and message as args, and should return {:ok, attribute_map} When a message is evaluated the callbacks above are run in the following order. when callbacks are evaluated to see if the current transition is ready to be executed. If not the next transition is tried. then callbacks are evaluated to update the instance state. user_actions is evaluated, all callbacks specified inside are executed and all user action tokens are calculated. update_history_entry callbacks are evaluated to update the new history entry update_possible_transition callbacks are evaluated to update the new possible future transitions upsert_attributes callbacks are evaluated to gather additional attributes side_effects callbacks are evaluated to acquire the list of all additional output actions All text bearing attributes (such as subject , name , description_before , description_after ) has access to incident metadata dictionary. This dictionary contains these, keys: id , which contains incident id transition , transition attributes dictionary containing from , to , severity keys state , dictionary containing user defined state message , altworx message which triggered given transition Metadata can be accessed via interpolation defined as {{}} , e.g. {{state.foo.bar}} , {{message.body.foo}} .","ref":"Toolbox.Incident.html#add_transition/2","title":"Toolbox.Incident.add_transition/2","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#append_create_incident_output_actions/3","title":"Toolbox.Incident.append_create_incident_output_actions/3","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#append_update_incident_output_actions/3","title":"Toolbox.Incident.append_update_incident_output_actions/3","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#build/1","title":"Toolbox.Incident.build/1","type":"function"},{"doc":"Uses given incident workflow definition and message to update state of given instance. If no configured workflow transition matches, nothing will happen = instance state will remain the same. Order of callback execution: when definitions of transitions in definition order then definitions of matching transition update history entry definitions of matching transition update possible transition definitions of matching transition side effects definitions of matching transition","ref":"Toolbox.Incident.html#handle_message/3","title":"Toolbox.Incident.handle_message/3","type":"function"},{"doc":"Creates new blank incident workflow definition","ref":"Toolbox.Incident.html#new/0","title":"Toolbox.Incident.new/0","type":"function"},{"doc":"Creates new incident instance for given workflow. params can be used to specify additional transition-like parameters. For available options see add_transition/2 .","ref":"Toolbox.Incident.html#new_instance/6","title":"Toolbox.Incident.new_instance/6","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#update_incident_history_entry/4","title":"Toolbox.Incident.update_incident_history_entry/4","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#update_incident_possible_transition/4","title":"Toolbox.Incident.update_incident_possible_transition/4","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#update_incident_state/3","title":"Toolbox.Incident.update_incident_state/3","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#update_user_actions/3","title":"Toolbox.Incident.update_user_actions/3","type":"function"},{"doc":"","ref":"Toolbox.Incident.html#validate_upsert_attributes/1","title":"Toolbox.Incident.validate_upsert_attributes/1","type":"function"},{"doc":"Module provides functions to generate incident id.","ref":"Toolbox.Incident.IdGenerator.html","title":"Toolbox.Incident.IdGenerator","type":"module"},{"doc":"Generates incident id based on incident type, timestamp and serialization_vector. Serialization vector is list of attributes relevant which together with type and timestamp identifies given incident. iex&gt; Toolbox.Incident.IdGenerator.generate(&quot;/incident/type&quot;, 0123456789, [&quot;/asset/type/1&quot;]) &quot;/incident/type/f4c3877a-d50b-3a16-b6ec-3ebb2b308d40&quot;","ref":"Toolbox.Incident.IdGenerator.html#generate/3","title":"Toolbox.Incident.IdGenerator.generate/3","type":"function"},{"doc":"Formerly delayed messages/late events, when jitter around incoming topic is out of threshold. Negative delay means message is too late (from past). Positive delay means message is too early (from future). Normalized messages is provided.","ref":"Toolbox.JitterMessage.html","title":"Toolbox.JitterMessage","type":"module"},{"doc":"See module Toolbox.JitterMessage info.","ref":"Toolbox.JitterMessage.html#t:t/0","title":"Toolbox.JitterMessage.t/0","type":"type"},{"doc":"Altworx message runtime representation.","ref":"Toolbox.Message.html","title":"Toolbox.Message","type":"module"},{"doc":"","ref":"Toolbox.Message.html#body/1","title":"Toolbox.Message.body/1","type":"function"},{"doc":"","ref":"Toolbox.Message.html#from/1","title":"Toolbox.Message.from/1","type":"function"},{"doc":"","ref":"Toolbox.Message.html#new/4","title":"Toolbox.Message.new/4","type":"function"},{"doc":"","ref":"Toolbox.Message.html#timestamp/1","title":"Toolbox.Message.timestamp/1","type":"function"},{"doc":"","ref":"Toolbox.Message.html#type/1","title":"Toolbox.Message.type/1","type":"function"},{"doc":"","ref":"Toolbox.Message.html#t:body/0","title":"Toolbox.Message.body/0","type":"type"},{"doc":"","ref":"Toolbox.Message.html#t:from/0","title":"Toolbox.Message.from/0","type":"type"},{"doc":"","ref":"Toolbox.Message.html#t:origin/0","title":"Toolbox.Message.origin/0","type":"type"},{"doc":"","ref":"Toolbox.Message.html#t:t/0","title":"Toolbox.Message.t/0","type":"type"},{"doc":"","ref":"Toolbox.Message.html#t:timestamp/0","title":"Toolbox.Message.timestamp/0","type":"type"},{"doc":"","ref":"Toolbox.Message.html#t:type/0","title":"Toolbox.Message.type/0","type":"type"},{"doc":"Generic load topic parser. Module parses encoded JSON objects with expected attributes. iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;create_asset&quot;,&quot;timestamp&quot;: 12345,&quot;asset_id&quot;: &quot;/asset/foo/bar&quot;,&quot;attributes&quot;: {&quot;attr1&quot;: &quot;attr1_val&quot;}}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :create_asset , timestamp : 12_345 , asset_id : &quot;/asset/foo/bar&quot; , attributes : %{ &quot;attr1&quot; =&gt; &quot;attr1_val&quot; } } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;upsert_asset&quot;,&quot;timestamp&quot;: 12345, &quot;asset_id&quot;: &quot;/asset/foo/bar&quot;, &quot;attributes&quot;: {&quot;attr1&quot;: &quot;attr1_val&quot;}}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :upsert_asset , timestamp : 12_345 , asset_id : &quot;/asset/foo/bar&quot; , attributes : %{ &quot;attr1&quot; =&gt; &quot;attr1_val&quot; } } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;update_asset&quot;,&quot;timestamp&quot;: 12345,&quot;asset_id&quot;: &quot;/asset/foo/bar&quot;,&quot;attributes&quot;: {&quot;attr1&quot;: &quot;attr1_val&quot;}}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :update_asset , timestamp : 12_345 , asset_id : &quot;/asset/foo/bar&quot; , attributes : %{ &quot;attr1&quot; =&gt; &quot;attr1_val&quot; } } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;delete_asset&quot;,&quot;timestamp&quot;: 12345,&quot;asset_id&quot;: &quot;/asset/foo/bar&quot;}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :delete_asset , timestamp : 12_345 , asset_id : &quot;/asset/foo/bar&quot; } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;create_edge&quot;,&quot;timestamp&quot;: 12345,&quot;from_asset_id&quot;: &quot;/asset/foo/1&quot;,&quot;to_asset_id&quot;: &quot;/asset/foo/2&quot;,&quot;edge_type&quot;: &quot;actor&quot;}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :create_edge , timestamp : 12_345 , from_asset_id : &quot;/asset/foo/1&quot; , to_asset_id : &quot;/asset/foo/2&quot; , edge_type : &quot;actor&quot; } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;upsert_edge&quot;,&quot;timestamp&quot;: 12345,&quot;from_asset_id&quot;: &quot;/asset/foo/1&quot;,&quot;to_asset_id&quot;: &quot;/asset/foo/2&quot;,&quot;edge_type&quot;: &quot;actor&quot;}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :upsert_edge , timestamp : 12_345 , from_asset_id : &quot;/asset/foo/1&quot; , to_asset_id : &quot;/asset/foo/2&quot; , edge_type : &quot;actor&quot; } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;1&quot;,&quot;type&quot;: &quot;delete_edge&quot;,&quot;timestamp&quot;: 12345,&quot;from_asset_id&quot;: &quot;/asset/foo/1&quot;,&quot;to_asset_id&quot;: &quot;/asset/foo/2&quot;,&quot;edge_type&quot;: &quot;actor&quot;}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;1&quot; , type : :delete_edge , timestamp : 12_345 , from_asset_id : &quot;/asset/foo/1&quot; , to_asset_id : &quot;/asset/foo/2&quot; , edge_type : &quot;actor&quot; } } iex&gt; raw_message = ~s({&quot;load_topic_message&quot;: &quot;2&quot;,&quot;type&quot;: &quot;update_asset&quot;,&quot;timestamp&quot;: 12345,&quot;asset_id&quot;: &quot;/asset/foo/bar&quot;,&quot;update_attributes&quot;: {&quot;attr1&quot;: &quot;attr1_val&quot;}, &quot;delete_attributes&quot;: {&quot;attr2&quot;: true}}) ...&gt; Toolbox.Normalizer.LoadTopic.Parser . parse ( raw_message ) { :ok , %{ load_topic_message : &quot;2&quot; , type : :update_asset , timestamp : 12_345 , asset_id : &quot;/asset/foo/bar&quot; , update_attributes : %{ &quot;attr1&quot; =&gt; &quot;attr1_val&quot; } , delete_attributes : %{ &quot;attr2&quot; =&gt; true } } }","ref":"Toolbox.Normalizer.LoadTopic.Parser.html","title":"Toolbox.Normalizer.LoadTopic.Parser","type":"module"},{"doc":"Parse raw message into load topic message","ref":"Toolbox.Normalizer.LoadTopic.Parser.html#parse/1","title":"Toolbox.Normalizer.LoadTopic.Parser.parse/1","type":"function"},{"doc":"","ref":"Toolbox.Normalizer.LoadTopic.Parser.html#t:parsed_load_topic_message/0","title":"Toolbox.Normalizer.LoadTopic.Parser.parsed_load_topic_message/0","type":"type"},{"doc":"Normalizer pipeline helper for generic load topic. This pipeline uses Toolbox.Normalizer.LoadTopic.Parser as a raw message parser. Example pipeline definition in config.ini : [ pipelines . reality_network_updates_1 ] input = reality_network_updates big_delay_policy = adjust definition = Toolbox.Normalizer.LoadTopic.Pipeline . parse_msg Pipeline expects raw messages to be encoded JSON objects. Structure of JSON object should be as follow. Every object has to have these 3 common attributes + few other type specific attributes. load topic message identification + version via load_topic_message attribute with string version (currently only &quot;1&quot; and &quot;2&quot; are supported) timestamp via timestamp attribute action type via type attribute Type create_asset attributes in version &quot;1&quot; of load message: asset_id attributes Type upsert_asset attributes in version &quot;1&quot; of load message: asset_id attributes Type update_asset attributes in version &quot;1&quot; of load message: asset_id attributes Type update_asset attributes in version &quot;2&quot; of load message: asset_id update_attributes delete_attributes Type delete_asset attributes in version &quot;1&quot; of load message: asset_id Type create_edge attributes in version &quot;1&quot; of load message: from_asset_id to_asset_id edge_type Type upsert_edge attributes in version &quot;1&quot; of load message: from_asset_id to_asset_id edge_type Type delete_edge attributes in version &quot;1&quot; of load message: from_asset_id to_asset_id edge_type These types of messages are transformed into corresponding Altworx message Toolbox.Normalizer.LoadTopic.Pipeline.load_topic_message/0 . For example raw message { &quot;load_topic_message&quot; : &quot;1&quot; , &quot;type&quot; : &quot;create_asset&quot; , &quot;timestamp&quot; : 12345 , &quot;asset_id&quot; : &quot;/asset/foo/bar&quot; , &quot;attributes&quot; : { &quot;attr1&quot; : &quot;attr1_val&quot; } } would produce this Altworx message % Toolbox.Message { type : :create_asset , timestamp : 12345 , body : %{ load_topic_message : &quot;1&quot; , asset_id : &quot;/asset/foo/bar&quot; , attributes : %{ &quot;attr1&quot; =&gt; &quot;attr1_val&quot; } } } Messages produced by this pipeline are compatible with Scenario.LoadScenario scenario.","ref":"Toolbox.Normalizer.LoadTopic.Pipeline.html","title":"Toolbox.Normalizer.LoadTopic.Pipeline","type":"module"},{"doc":"","ref":"Toolbox.Normalizer.LoadTopic.Pipeline.html#parse_msg/1","title":"Toolbox.Normalizer.LoadTopic.Pipeline.parse_msg/1","type":"function"},{"doc":"","ref":"Toolbox.Normalizer.LoadTopic.Pipeline.html#t:load_topic_message/0","title":"Toolbox.Normalizer.LoadTopic.Pipeline.load_topic_message/0","type":"type"},{"doc":"Set of utility functions for use in notification templates.","ref":"Toolbox.Notifications.TemplateHelper.html","title":"Toolbox.Notifications.TemplateHelper","type":"module"},{"doc":"Returns a URL to the asset detail. The type of UI can be specified, and the link is generated to work with that UI. Can be :new or :old .","ref":"Toolbox.Notifications.TemplateHelper.html#asset_link/2","title":"Toolbox.Notifications.TemplateHelper.asset_link/2","type":"function"},{"doc":"Formats a number by separating thousands with a separator.","ref":"Toolbox.Notifications.TemplateHelper.html#format_number/2","title":"Toolbox.Notifications.TemplateHelper.format_number/2","type":"function"},{"doc":"Formats timestamp into the given format in the given timezone.","ref":"Toolbox.Notifications.TemplateHelper.html#format_ts/3","title":"Toolbox.Notifications.TemplateHelper.format_ts/3","type":"function"},{"doc":"Wraps the given EEx content with a EEx template. Templates can be bundled with a scenario or be a part of the system, source should be set to scenario_name for scenario-based templates and :system for templates bundled with the system. The templates that can be included, so called shared templates, are stored in shared folder ( scenarios/priv/notifications/{scenario_name}/shared ). Each shared template consists of two files - header and footer - which are wrapped around the given content. The filenames have _header and _footer appended, for template_name = &quot;email&quot; the two filenames are email_header.eex and email_footer.eex . System templates are stored in apps/asset_map/templates/shared . Via context you can pass additional parameters to the shared template (passed as assigns). The expected context depends on the template. Example usage &lt; % alias Toolbox.Notifications.TemplateHelper % &gt; &lt; % require TemplateHelper % &gt; &lt; % = TemplateHelper . include_template ( { &quot;test&quot; , 1 } , &quot;email_rich&quot; , title : &quot;Test email&quot; ) do % &gt; &lt; h1 &gt; Test Email &lt; / h1 &gt; &lt; p &gt; This text is surrounded by the template ... &lt; / p &gt; &lt; % end % &gt;","ref":"Toolbox.Notifications.TemplateHelper.html#include_template/4","title":"Toolbox.Notifications.TemplateHelper.include_template/4","type":"macro"},{"doc":"Returns the UI url.","ref":"Toolbox.Notifications.TemplateHelper.html#ui_url/0","title":"Toolbox.Notifications.TemplateHelper.ui_url/0","type":"function"},{"doc":"Functions for working with deterministic (pseudo)randomness in scenarios. In some use cases, scenarios need to behave “randomly”, for example, when a scenario serves as a demo events generator. Scenarios are by design deterministic which means that they can only behave randomly in the sense that they make certain decisions “on their own” (without the programmer explicitly choosing the outcome) but every time a scenario run is repeated, the same “random” decisions are made. To make this possible, the seed of the random number generator has to be always initialized to the same value and managed in the way that it is preserved throughout the run. And that is what this module helps with. The module wraps around Erlang :rand module for random number generation. Functions in the :rand module use process dictionary for storing the random number generator state (i.e. the seed). To be able to restore a run, the random number generator state is also kept in the state of a unit in an opaque field called __rand_seed . There are three steps (functions of this module) in order to use randomness in scenarios. First, you have to initialize the unit that uses randomness with init/2 . And then, every time before you want to use randomness, you have to call load/1 with the particular unit. And then store the new seed with save/1 . An example is given below. See the documentation for each of the functions for more detailed information. Example defmodule Scenarios.MyScenario.MyTemplate @behaviour Toolbox.Scenario.Template.StageBased alias Toolbox.Random def instances do # singleton unit [ { :unit , &quot;generator&quot; , %{ } } ] end def init ( _start_from , unit ) do unit = Random . init ( unit , 293732 ) { :ok , [ ] , unit } end def handle_message ( msg , unit ) do Random . load ( unit ) ... do something that uses :rand calls ... ( e . g . :rand . uniform / 0 or Enum . random / 1 ) { :noreply , oas , Random . save ( unit ) } end end","ref":"Toolbox.Random.html","title":"Toolbox.Random","type":"module"},{"doc":"Shortcut for init/2 called with __MODULE__ as the seed. It is a bit shorter, but on the other hand you have to require Toolbox.Random to be able to use this macro. Beware that the generated values will differ when you rename your template module.","ref":"Toolbox.Random.html#init/1","title":"Toolbox.Random.init/1","type":"macro"},{"doc":"Initializes a unit for random number generation. You need to provide an initial seed which may be any term, in particular any integer, string or atom. The value doesn't matter (it only affects the randomly generated values) as long as it is constant. Typically, you would use this function inside the init/2 callback of your template. In case you are using a singleton unit, you may, for example, hardcode an integer here or use __MODULE__ as the initial seed: def init ( _start_from , unit ) do unit = Random . init ( unit , __MODULE__ ) { :ok , [ ] , unit } end If you have multiple units (e.g. unit for each person), you may initialize each unit with a different seed (e.g. the ID of that person): def init ( _start_from , unit ) do unit = Random . init ( unit , unit . attributes . id ) { :ok , [ ] , unit } end This function saves the initial seed into the unit's state under an opaque field called __rand_seed and return the modified unit. Therefore, to use randomness, the unit's state has to be a map. The function also sets the seed in the process dictionary so you can start using randomness right away. But you will probably want to do so later in the handle_message/2 callback.","ref":"Toolbox.Random.html#init/2","title":"Toolbox.Random.init/2","type":"function"},{"doc":"Loads a seed from the unit's state into the process dictionary. Typically, you would call this function in the beginning of a handle_message/2 callback that deals with randomness. It is sufficient to call it once per invocation of the callback. Example def handle_message ( msg , unit ) do Random . load ( unit ) person = Enum . random ( unit . state . people ) room = Enum . random ( unit . state . rooms ) # generate an event that $person went into $room { :noreply , oas , Random . save ( unit ) } end","ref":"Toolbox.Random.html#load/1","title":"Toolbox.Random.load/1","type":"function"},{"doc":"Stores the random generator state in the unit's state. Typically, you would use this function after generating random values (and thus modifying the generator's seed) in the handle_message/2 callback. The function returns the modified unit.","ref":"Toolbox.Random.html#save/1","title":"Toolbox.Random.save/1","type":"function"},{"doc":"","ref":"Toolbox.Random.html#t:input_seed/0","title":"Toolbox.Random.input_seed/0","type":"type"},{"doc":"","ref":"Toolbox.Random.html#t:seed/0","title":"Toolbox.Random.seed/0","type":"type"},{"doc":"Behaviour module for notification reports. This behaviour encapsulates notifications which behave like reports = notifications are sent periodically. Example defmodule Scenarios.Template.Reporter do @callback Toolbox.Scenario.Template.StageBased alias Crontab.CronExpression alias Scenarios.Template.Reporter.DailyReport alias Toolbox.Message alias Toolbox.Report alias Toolbox.Runtime.Stage.Unit alias Toolbox.Scenario.OutputAction import Crontab.CronExpression @impl true def init ( init_timestamp , % Unit { } = unit ) do # report schedule defined as crontab expression report_schedule = ~e[* * * * *] # timezone used to display localized timestamp in notification timezone = &quot;Europe/Prague&quot; # args to init report state init_arg = :ok { :ok , outputs , report_state } = Report . init ( DailyReport , init_timestamp , report_schedule , timezone , init_arg ) { :ok , outputs , % Unit { unit | state : %{ report_state : report_state } } } end @impl true def handle_message ( % Message { } = msg , % Unit { } = unit ) do { :ok , outputs , report_state } = Report . process_message ( unit . state . report_state , msg ) { :reply , outputs , % Unit { unit | state : %{ unit . state | report_state : report_state } } } end end defmodule Scenarios.Template.Reporter.DailyReport do @callback Toolbox.Report alias Toolbox.Message alias Toolbox.Scenario.OutputAction @impl true def init ( :ok ) do { :ok , [ ] , %{ incomming_messages : [ ] } } end @impl true def handle_process_message ( %{ } = state , % Message { } = msg ) do { :ok , [ ] , %{ incomming_messages : [ msg | state . incomming_messages ] } } end @impl true def handle_publish_report ( %{ } = state , publish_timestamp , last_publish_timestamp ) do report_notification = OutputAction . new_notification_action ( publish_timestamp , %{ type : :daily_report , primary_asset : nil , data : %{ &quot;incomming_messages&quot; =&gt; state . incomming_messages , &quot;publish_time&quot; =&gt; publish_timestamp , &quot;last_publish_time&quot; =&gt; last_timestamp } } ) { :ok , [ report_notification ] , %{ incomming_messages : [ ] } } end end","ref":"Toolbox.Report.html","title":"Toolbox.Report","type":"behaviour"},{"doc":"","ref":"Toolbox.Report.html#c:handle_process_message/2","title":"Toolbox.Report.handle_process_message/2","type":"callback"},{"doc":"","ref":"Toolbox.Report.html#c:handle_publish_report/3","title":"Toolbox.Report.handle_publish_report/3","type":"callback"},{"doc":"","ref":"Toolbox.Report.html#c:init/1","title":"Toolbox.Report.init/1","type":"callback"},{"doc":"Initializes report","ref":"Toolbox.Report.html#init/5","title":"Toolbox.Report.init/5","type":"function"},{"doc":"Processes report message","ref":"Toolbox.Report.html#process_message/2","title":"Toolbox.Report.process_message/2","type":"function"},{"doc":"Resolves date time into non-ambiguous DateTime. If AmbiguousDateTime is given, it picks one version. If any other non-ambiguous date time is given it is returned as is.","ref":"Toolbox.Report.html#resolve_ambiguous_datetime/1","title":"Toolbox.Report.resolve_ambiguous_datetime/1","type":"function"},{"doc":"","ref":"Toolbox.Report.html#t:report_state/0","title":"Toolbox.Report.report_state/0","type":"type"},{"doc":"","ref":"Toolbox.Report.html#t:timestamp/0","title":"Toolbox.Report.timestamp/0","type":"type"},{"doc":"Report state","ref":"Toolbox.Report.State.html","title":"Toolbox.Report.State","type":"module"},{"doc":"","ref":"Toolbox.Report.State.html#t:t/0","title":"Toolbox.Report.State.t/0","type":"type"},{"doc":"Struct produced by scenario representing instruction for runtime.","ref":"Toolbox.Runtime.RuntimeInstruction.html","title":"Toolbox.Runtime.RuntimeInstruction","type":"module"},{"doc":"Creates runtime instruction to register unit timeout from a message.","ref":"Toolbox.Runtime.RuntimeInstruction.html#register_timeout/1","title":"Toolbox.Runtime.RuntimeInstruction.register_timeout/1","type":"function"},{"doc":"Creates runtime instruction to register unit timeout by giving the target time and message. Note that the timeout and timeout_message.timestamp should specify the same timestamp, unless unexpected things can happen.","ref":"Toolbox.Runtime.RuntimeInstruction.html#register_timeout/2","title":"Toolbox.Runtime.RuntimeInstruction.register_timeout/2","type":"function"},{"doc":"Creates runtime instruction to start incident process in server based runtime.","ref":"Toolbox.Runtime.RuntimeInstruction.html#start_incident/6","title":"Toolbox.Runtime.RuntimeInstruction.start_incident/6","type":"function"},{"doc":"Struct produced by scenario representing instruction for runtime.","ref":"Toolbox.Runtime.RuntimeInstruction.html#t:t/0","title":"Toolbox.Runtime.RuntimeInstruction.t/0","type":"type"},{"doc":"Struct representing instruction to start incident process in server based runtime.","ref":"Toolbox.Runtime.RuntimeInstruction.StartIncident.html","title":"Toolbox.Runtime.RuntimeInstruction.StartIncident","type":"module"},{"doc":"Struct representing instruction to start incident process in server based runtime.","ref":"Toolbox.Runtime.RuntimeInstruction.StartIncident.html#t:t/0","title":"Toolbox.Runtime.RuntimeInstruction.StartIncident.t/0","type":"type"},{"doc":"Instruction to register unit timeout.","ref":"Toolbox.Runtime.RuntimeInstruction.Timeout.html","title":"Toolbox.Runtime.RuntimeInstruction.Timeout","type":"module"},{"doc":"Struct representing unit timeout registration.","ref":"Toolbox.Runtime.RuntimeInstruction.Timeout.html#t:t/0","title":"Toolbox.Runtime.RuntimeInstruction.Timeout.t/0","type":"type"},{"doc":"Struct representing a unit.","ref":"Toolbox.Runtime.Stage.Unit.html","title":"Toolbox.Runtime.Stage.Unit","type":"module"},{"doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#attributes/1","title":"Toolbox.Runtime.Stage.Unit.attributes/1","type":"function"},{"doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#id/1","title":"Toolbox.Runtime.Stage.Unit.id/1","type":"function"},{"doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#new/3","title":"Toolbox.Runtime.Stage.Unit.new/3","type":"function"},{"doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#set_state/2","title":"Toolbox.Runtime.Stage.Unit.set_state/2","type":"function"},{"doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#state/1","title":"Toolbox.Runtime.Stage.Unit.state/1","type":"function"},{"doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#t:t/0","title":"Toolbox.Runtime.Stage.Unit.t/0","type":"type"},{"doc":"Library for scenario modules.","ref":"Toolbox.Scenario.html","title":"Toolbox.Scenario","type":"module"},{"doc":"","ref":"Toolbox.Scenario.html#get_impl_for/1","title":"Toolbox.Scenario.get_impl_for/1","type":"function"},{"doc":"","ref":"Toolbox.Scenario.html#manifest_module?/1","title":"Toolbox.Scenario.manifest_module?/1","type":"function"},{"doc":"","ref":"Toolbox.Scenario.html#template_module?/2","title":"Toolbox.Scenario.template_module?/2","type":"function"},{"doc":"Provides configuration to a scenario.","ref":"Toolbox.Scenario.Config.html","title":"Toolbox.Scenario.Config","type":"module"},{"doc":"Read file from the config dir. The file is located in the configuration directory, in a folder matching the scenario_id param. The file is read if it exists and content is returned as {:ok, content} , otherwise {:error, reason} is returned.","ref":"Toolbox.Scenario.Config.html#read_file/2","title":"Toolbox.Scenario.Config.read_file/2","type":"function"},{"doc":"Resolves a path to a file in scenario config. The file is located in the configuration directory, in a folder matching the scenario_id param. This function resolves the path so that it can be used with File functions directly. The existence of the file is not verified. Note if you want to just read the file, you can use read_file/2 , this function should be used when you need to handle the file in a special manner (e.g. streaming).","ref":"Toolbox.Scenario.Config.html#resolve_file/2","title":"Toolbox.Scenario.Config.resolve_file/2","type":"function"},{"doc":"Support for helper processes for scenarios. Provides a supervisor and process registry under which scenarios can start their side-kick processes intended for housekeeping tasks.","ref":"Toolbox.Scenario.Helper.html","title":"Toolbox.Scenario.Helper","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Toolbox.Scenario.Helper.html#child_spec/1","title":"Toolbox.Scenario.Helper.child_spec/1","type":"function"},{"doc":"Starts a supervisor with dynamic supervisor and process registry.","ref":"Toolbox.Scenario.Helper.html#start_link/1","title":"Toolbox.Scenario.Helper.start_link/1","type":"function"},{"doc":"Returns a :via name to be used in the helper process registry.","ref":"Toolbox.Scenario.Helper.html#via_registry/1","title":"Toolbox.Scenario.Helper.via_registry/1","type":"function"},{"doc":"Executes a given callback over running helper. Checks whether the helper with name registered under helper registry is already running. If not, then it starts the process according to child_spec under the dynamic supervisor. In either case, it passes the helper process pid to the callback . It is the responsibility of the helper process to register its name with the helper registry via the via_registry/1 . Examples iex&gt; child_spec = %{ ...&gt; id : MyHelper , ...&gt; start : { ...&gt; Agent , ...&gt; :start_link , ...&gt; [ fn -&gt; 1 end , [ name : Helper . via_registry ( MyHelper ) ] ] ...&gt; } ...&gt; } iex&gt; :ok = Helper . with_helper ( MyHelper , child_spec , fn pid -&gt; Agent . update ( pid , &amp; &amp;1 + 1 ) end ) iex&gt; Helper . with_helper ( MyHelper , child_spec , fn pid -&gt; Agent . get ( pid , &amp; &amp;1 ) end ) 2","ref":"Toolbox.Scenario.Helper.html#with_helper/3","title":"Toolbox.Scenario.Helper.with_helper/3","type":"function"},{"doc":"Behaviour and struct for scenario manifest.","ref":"Toolbox.Scenario.Manifest.html","title":"Toolbox.Scenario.Manifest","type":"behaviour"},{"doc":"Invoked to obtain the scenario manifest.","ref":"Toolbox.Scenario.Manifest.html#c:get_info/0","title":"Toolbox.Scenario.Manifest.get_info/0","type":"callback"},{"doc":"Invoked once when the scenario run starts. Useful for doing any necessary preparations for scenario run. Warning: Do not rely on any external resources (e.g. SQL queries) which may change the scenario logic. This callback is optional. If it is not implemented, no action is performed when starting the scenario run.","ref":"Toolbox.Scenario.Manifest.html#c:on_start/0","title":"Toolbox.Scenario.Manifest.on_start/0","type":"callback"},{"doc":"Assets group attributes metadata. Metadata helps the UI to render form for the group attributes definition. Attributes of the group are saved in asset attributes in Reality Network if group is materialized as asset in Reality Network. Properties :name - user-friendly attribute name - what is set. :description - longer attribute description - what the attribute does, the unit, ... :path - path to attribute in attributes JSON. :type - type of attribute value (helps the UI to render form input).","ref":"Toolbox.Scenario.Manifest.html#t:attribute_detail/0","title":"Toolbox.Scenario.Manifest.attribute_detail/0","type":"type"},{"doc":"Metadata (template) of assets group. The scenario should be able to carry a list of groups it uses. These groups can then be easily created in the UI by the user without having to fill in some information manually. Metadata defines these helpers for the UI. Properties :name - short name of group template for UI. :description - description of assets group. :asset_type - asset type of asset created by the group. :edge_type - edge type for connecting assets in the group. :edge_direction - edge direction (true = from group asset to assets in group). :attributes - description of group attributes.","ref":"Toolbox.Scenario.Manifest.html#t:group_of_assets/0","title":"Toolbox.Scenario.Manifest.group_of_assets/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.Manifest.html#t:t/0","title":"Toolbox.Scenario.Manifest.t/0","type":"type"},{"doc":"Struct representing incident manifest","ref":"Toolbox.Scenario.Manifest.Incident.html","title":"Toolbox.Scenario.Manifest.Incident","type":"module"},{"doc":"","ref":"Toolbox.Scenario.Manifest.Incident.html#t:t/0","title":"Toolbox.Scenario.Manifest.Incident.t/0","type":"type"},{"doc":"Struct representing one column in incident forecast UI widget. Properties: :name displayed column name :since time frame start interval in ms :till time frame end interval in ms","ref":"Toolbox.Scenario.Manifest.IncidentFrame.html","title":"Toolbox.Scenario.Manifest.IncidentFrame","type":"module"},{"doc":"","ref":"Toolbox.Scenario.Manifest.IncidentFrame.html#t:t/0","title":"Toolbox.Scenario.Manifest.IncidentFrame.t/0","type":"type"},{"doc":"Toolbox for formatting notifications.","ref":"Toolbox.Scenario.Notification.html","title":"Toolbox.Scenario.Notification","type":"module"},{"doc":"Formats emails to a list of maps used for direct_subscriptions in Toolbox.Scenario.OutputAction . Examples iex&gt; Toolbox.Scenario.Notification . format_direct_subscriptions ( [ &quot;john.lennon@example.com&quot; ] ) [ %{ &quot;channels&quot; =&gt; [ &quot;gmail&quot; ] , &quot;templates&quot; =&gt; [ &quot;default&quot; ] , &quot;user&quot; =&gt; %{ &quot;contact&quot; =&gt; %{ &quot;email&quot; =&gt; &quot;john.lennon@example.com&quot; } } } ]","ref":"Toolbox.Scenario.Notification.html#format_direct_subscriptions/1","title":"Toolbox.Scenario.Notification.format_direct_subscriptions/1","type":"function"},{"doc":"Struct representing side effects produced by run. There are several constructor functions to simplify and standardize side effect definition. Instances of this struct are being parsed and then passed to output server.","ref":"Toolbox.Scenario.OutputAction.html","title":"Toolbox.Scenario.OutputAction","type":"module"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#body/1","title":"Toolbox.Scenario.OutputAction.body/1","type":"function"},{"doc":"Constructor for calling SQL query. First argument is unix timestamp and second is body , which is map with 4 required keys: db_connection , sql_query , data and type . db_connection - map with database connection info ( hostname , username , password , database ) sql_query - SQL query. data - list of parameterized data. type - database type, right now only PostgreSQL is supported. It's checked in OutputProcessor and the value must be :postgresql . If :run_id is present in data , it's replaced with actual run_id in AssetMap.Api.SqlExecutor .","ref":"Toolbox.Scenario.OutputAction.html#execute_sql_action/2","title":"Toolbox.Scenario.OutputAction.execute_sql_action/2","type":"function"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#new/2","title":"Toolbox.Scenario.OutputAction.new/2","type":"function"},{"doc":"Constructor for create new asset side effect.","ref":"Toolbox.Scenario.OutputAction.html#new_create_asset_action/3","title":"Toolbox.Scenario.OutputAction.new_create_asset_action/3","type":"function"},{"doc":"Constructor for create edge between assets side effect.","ref":"Toolbox.Scenario.OutputAction.html#new_create_edge_action/5","title":"Toolbox.Scenario.OutputAction.new_create_edge_action/5","type":"function"},{"doc":"Constructor for delete asset side effect.","ref":"Toolbox.Scenario.OutputAction.html#new_delete_asset_action/2","title":"Toolbox.Scenario.OutputAction.new_delete_asset_action/2","type":"function"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#new_delete_edge_action/5","title":"Toolbox.Scenario.OutputAction.new_delete_edge_action/5","type":"function"},{"doc":"Constructor for event side effect. First argument is unix timestamp and second is body , which is map with 3 required keys: actors , type and template . actors - map of actors which are interpolated in the template. params - map of template params that are interpolated in the template. origin_messages - list of raw messages linked with the event itself. template - event's template. See AssetMap.Events.Template . type - type of the event. It's declared in Scenario's Manifest.","ref":"Toolbox.Scenario.OutputAction.html#new_event_action/2","title":"Toolbox.Scenario.OutputAction.new_event_action/2","type":"function"},{"doc":"Constructor for new incident (add_asset) action","ref":"Toolbox.Scenario.OutputAction.html#new_incident_action/2","title":"Toolbox.Scenario.OutputAction.new_incident_action/2","type":"function"},{"doc":"Constructor for notification side effect. Params describe the notification to be created. It has the following keys :type - string, type of the notification :data - map, data for the template evaluation :primary_asset - string, optional, id of an asset that corresponds to this notification :ids - list of asset ids, optional, to filter recipients, each recipient must have sufficient privileges to see all listed IDs :aqls - map, AQLs which are evaluated, provide further context to the templates, and also can serve the same purpose as ids - filter recipients to only those who can see the whole result of the query. Key is the name of the AQL which can be used in the template. Value is a map with aql (the AQL query) and primary (whether the AQL should also be used to filter recipients) keys. :priority - optional, defaults to :medium , can be :low , :medium , :high , only applicable to some channels :metadata - map, optional, additional metadata which can be used in notification group subscriptions. Should adhere to the format specified in notification/spec.exs . :direct_subscriptions - list of maps, subscriptions to be used additionally to the usual routing. Each map should have the following. :user - map, user object to be used instead of Altworx object, should have notification.email and optionally even notification.language . :templates - list of ids, which templates should be used :channels - list of ids, which channels should be used :attachments - list of maps, optional, attachments that should be sent with the notification. Each map has the following keys. data - binary, content of the attachment filename - string, name of the file content_type - string, optional, MIME type of the data type - whether the attachment is to inlined in the template ( :inline ) or not ( :attachment , this is the default)","ref":"Toolbox.Scenario.OutputAction.html#new_notification_action/2","title":"Toolbox.Scenario.OutputAction.new_notification_action/2","type":"function"},{"doc":"Constructor for update existing asset side effect.","ref":"Toolbox.Scenario.OutputAction.html#new_update_asset_action/4","title":"Toolbox.Scenario.OutputAction.new_update_asset_action/4","type":"function"},{"doc":"Constructor for upsert asset side effect.","ref":"Toolbox.Scenario.OutputAction.html#new_upsert_asset_action/3","title":"Toolbox.Scenario.OutputAction.new_upsert_asset_action/3","type":"function"},{"doc":"Constructor for upsert edge between assets side effect.","ref":"Toolbox.Scenario.OutputAction.html#new_upsert_edge_action/5","title":"Toolbox.Scenario.OutputAction.new_upsert_edge_action/5","type":"function"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#set_body/2","title":"Toolbox.Scenario.OutputAction.set_body/2","type":"function"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#set_type/2","title":"Toolbox.Scenario.OutputAction.set_type/2","type":"function"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#type/1","title":"Toolbox.Scenario.OutputAction.type/1","type":"function"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#t:t/0","title":"Toolbox.Scenario.OutputAction.t/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.html#t:type/0","title":"Toolbox.Scenario.OutputAction.type/0","type":"type"},{"doc":"Body for Asset output actions","ref":"Toolbox.Scenario.OutputAction.Asset.html","title":"Toolbox.Scenario.OutputAction.Asset","type":"module"},{"doc":"Body structure of Asset output actions","ref":"Toolbox.Scenario.OutputAction.Asset.html#t:t/0","title":"Toolbox.Scenario.OutputAction.Asset.t/0","type":"type"},{"doc":"Body for asset attributes patch output action. Describes a patch (a change) in attributes, some attributes can change ( update ), some may be completely removed ( delete ).","ref":"Toolbox.Scenario.OutputAction.AssetPatch.html","title":"Toolbox.Scenario.OutputAction.AssetPatch","type":"module"},{"doc":"Body for asset attributes patch output action","ref":"Toolbox.Scenario.OutputAction.AssetPatch.html#t:t/0","title":"Toolbox.Scenario.OutputAction.AssetPatch.t/0","type":"type"},{"doc":"Body for Edge output actions","ref":"Toolbox.Scenario.OutputAction.Edge.html","title":"Toolbox.Scenario.OutputAction.Edge","type":"module"},{"doc":"Body structure of Edge output actions","ref":"Toolbox.Scenario.OutputAction.Edge.html#t:t/0","title":"Toolbox.Scenario.OutputAction.Edge.t/0","type":"type"},{"doc":"Body for new Incident action","ref":"Toolbox.Scenario.OutputAction.Incident.html","title":"Toolbox.Scenario.OutputAction.Incident","type":"module"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.Incident.html#t:resolution/0","title":"Toolbox.Scenario.OutputAction.Incident.resolution/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.Incident.html#t:severity/0","title":"Toolbox.Scenario.OutputAction.Incident.severity/0","type":"type"},{"doc":"Body for new Incident action","ref":"Toolbox.Scenario.OutputAction.Incident.html#t:t/0","title":"Toolbox.Scenario.OutputAction.Incident.t/0","type":"type"},{"doc":"Struct for Incident State","ref":"Toolbox.Scenario.OutputAction.IncidentState.html","title":"Toolbox.Scenario.OutputAction.IncidentState","type":"module"},{"doc":"","ref":"Toolbox.Scenario.OutputAction.IncidentState.html#t:severity/0","title":"Toolbox.Scenario.OutputAction.IncidentState.severity/0","type":"type"},{"doc":"Struct for Incident State","ref":"Toolbox.Scenario.OutputAction.IncidentState.html#t:t/0","title":"Toolbox.Scenario.OutputAction.IncidentState.t/0","type":"type"},{"doc":"Module defines behaviour used in scenarios as template. Scenario template implementations are main components of scenario. Runtime uses callbacks of this behaviour to start scenario in run and to handle incomming messages. Each template behaviour implementation is represented as separate process in runtime called TemplateCarrier . Template is inteded to be used to model behaviour of assets of single type per template. Individual asset states are represented as Toolbox.Runtime.Stage.Unit.t/0 . Initial assets are defined via Toolbox.Scenario.Template.StageBased.instances/0 callback. This callback should return list of unit definitions ( Toolbox.Scenario.Template.StageBased.instances_def/0 ). Templates are linked together via subscriptions provided by callback Toolbox.Scenario.Template.StageBased.subscriptions/0 . Subscription is defined as tuple containing component definition and routing rule list. It is possible to subscribe to other templates, input and load topics. Routing rules are used to locate units when message is handled. When routing rule succeeds, callback Toolbox.Scenario.Template.StageBased.handle_message/2 is called, when routing rule fails to locat existing unit, Toolbox.Scenario.Template.StageBased.handle_asset_discovery/1 gets called instead. Unit initialization can produce side effects via Toolbox.Scenario.Template.StageBased.init/2 callback. This callback is triggered when instances are produced by Toolbox.Scenario.Template.StageBased.instances/0 or Toolbox.Scenario.Template.StageBased.handle_asset_discovery/1 callbacks. Units are already registered in the time when this callback is triggered, so changes in unit attributes won't change unit registration (defined by Toolbox.Scenario.Template.StageBased.subscriptions/0 ). When message from subscribed publisher is handled by the TemplateCarrier , runtime tries to locate asset unit using given subscription configuration. If there is such a unit, runtime calls Toolbox.Scenario.Template.StageBased.handle_message/2 callback and uses message and located message as attributes. In case that no unit was found, Toolbox.Scenario.Template.StageBased.handle_asset_discovery/1 gets called instead.","ref":"Toolbox.Scenario.Template.StageBased.html","title":"Toolbox.Scenario.Template.StageBased","type":"behaviour"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#c:handle_asset_discovery/1","title":"Toolbox.Scenario.Template.StageBased.handle_asset_discovery/1","type":"callback"},{"doc":"Invokes template_module.asset_discovery with given message .","ref":"Toolbox.Scenario.Template.StageBased.html#handle_asset_discovery/2","title":"Toolbox.Scenario.Template.StageBased.handle_asset_discovery/2","type":"function"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#c:handle_message/2","title":"Toolbox.Scenario.Template.StageBased.handle_message/2","type":"callback"},{"doc":"Invokes template_module.handle_message with given message and unit .","ref":"Toolbox.Scenario.Template.StageBased.html#handle_message/3","title":"Toolbox.Scenario.Template.StageBased.handle_message/3","type":"function"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#c:init/2","title":"Toolbox.Scenario.Template.StageBased.init/2","type":"callback"},{"doc":"Updates unit and sets initial unit state.","ref":"Toolbox.Scenario.Template.StageBased.html#init/3","title":"Toolbox.Scenario.Template.StageBased.init/3","type":"function"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#c:instances/0","title":"Toolbox.Scenario.Template.StageBased.instances/0","type":"callback"},{"doc":"Returns list of of asset units.","ref":"Toolbox.Scenario.Template.StageBased.html#instances/1","title":"Toolbox.Scenario.Template.StageBased.instances/1","type":"function"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#c:subscriptions/0","title":"Toolbox.Scenario.Template.StageBased.subscriptions/0","type":"callback"},{"doc":"Returns subscriptions defined in template_module .","ref":"Toolbox.Scenario.Template.StageBased.html#subscriptions/1","title":"Toolbox.Scenario.Template.StageBased.subscriptions/1","type":"function"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#t:handle_asset_discovery_resp/0","title":"Toolbox.Scenario.Template.StageBased.handle_asset_discovery_resp/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#t:handle_message_resp/0","title":"Toolbox.Scenario.Template.StageBased.handle_message_resp/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#t:instances_def/0","title":"Toolbox.Scenario.Template.StageBased.instances_def/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#t:routing_key_definition/0","title":"Toolbox.Scenario.Template.StageBased.routing_key_definition/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#t:subscription_def/0","title":"Toolbox.Scenario.Template.StageBased.subscription_def/0","type":"type"},{"doc":"","ref":"Toolbox.Scenario.Template.StageBased.html#t:template_output/0","title":"Toolbox.Scenario.Template.StageBased.template_output/0","type":"type"},{"doc":"Behaviour used to detect scenario template source files.","ref":"Toolbox.Scenario.TemplateInspector.html","title":"Toolbox.Scenario.TemplateInspector","type":"behaviour"},{"doc":"","ref":"Toolbox.Scenario.TemplateInspector.html#c:template_info/1","title":"Toolbox.Scenario.TemplateInspector.template_info/1","type":"callback"},{"doc":"Retrieve implementation specific information about a template.","ref":"Toolbox.Scenario.TemplateInspector.html#template_info/2","title":"Toolbox.Scenario.TemplateInspector.template_info/2","type":"function"},{"doc":"","ref":"Toolbox.Scenario.TemplateInspector.html#c:valid_template?/1","title":"Toolbox.Scenario.TemplateInspector.valid_template?/1","type":"callback"},{"doc":"Validate whether given module is valid template source file.","ref":"Toolbox.Scenario.TemplateInspector.html#valid_template?/2","title":"Toolbox.Scenario.TemplateInspector.valid_template?/2","type":"function"},{"doc":"Definition of action to be fired from UI. In scenario list of Toolbox.Scenario.UIAction s is defined and stored in asset map entity. When action is fired from UI, scenario receives Toolbox.Scenario.UserAction .","ref":"Toolbox.Scenario.UIAction.html","title":"Toolbox.Scenario.UIAction","type":"module"},{"doc":"Converts list of UI actions to actions property. Map in resulting list contains two properties: action - action ( topic , type , details ) encoded to JWT. meta - metadata ( name , description ) to be used in UI. Resulting list of maps should be stored to some entity in asset map.","ref":"Toolbox.Scenario.UIAction.html#actions/1","title":"Toolbox.Scenario.UIAction.actions/1","type":"function"},{"doc":"UI action definition. Properties topic , type and details are serialized to JWT token and used for routing of fired action. Property topic is name of raw topic where fired actions are pushed, property type is type to be used in Toolbox.Message as type and property details is stored in resulting message body as details property. Properties name and description are only metadata for UI.","ref":"Toolbox.Scenario.UIAction.html#t:t/0","title":"Toolbox.Scenario.UIAction.t/0","type":"type"},{"doc":"Toolbox for working with scenario user actions. User action is action created by scenario via Toolbox.Scenario.UIAction and fired by user (usually from UI). Scenario is usually also a receiver of fired action. Assumed workflow is following: Scenario creates list of actions (using Toolbox.Scenario.UIAction ) to be fired in the future and saves it somewhere (in incident asset for example). UI displays available actions. User fires selected action from UI. UI pushes the action to raw Kafka topic (defined in action) with extra data attached (usually some comment). Normalizer pipeline recieves the action and sends it to target scenario.","ref":"Toolbox.Scenario.UserAction.html","title":"Toolbox.Scenario.UserAction","type":"module"},{"doc":"Unpacks action and makes it fired (prepared for sending to target topic). Routing properties ( type , details ) are propagated from packed action, user and data properties are attached to fired action. Target topic is also extracted from packed action. Returns error if packed action (JWT) is not valid.","ref":"Toolbox.Scenario.UserAction.html#fire/3","title":"Toolbox.Scenario.UserAction.fire/3","type":"function"},{"doc":"Helper for UserAction forwading to be used in normalizer. If helper is used in normalizer pipeline configuration in config.ini like [ pipelines . some_pipeline ] definition = Toolbox.Scenario.UserAction . normalizer_pipeline_step than Toolbox.Message body will contain fired Toolbox.Scenario.UserAction .","ref":"Toolbox.Scenario.UserAction.html#normalizer_pipeline_step/1","title":"Toolbox.Scenario.UserAction.normalizer_pipeline_step/1","type":"function"},{"doc":"Packs user action to JWT to be used (fired) later (from UI for example). Parameter details must be a map encodable to JSON. Because details can be (and it is!) encoded/decoded to/from JSON during its life-cycle, atom property names of details are always converted to string property names in fired action's details . JWT is not used for security reasons - it is just good enough envelope protecting action against accidental corruption on its journey.","ref":"Toolbox.Scenario.UserAction.html#pack/3","title":"Toolbox.Scenario.UserAction.pack/3","type":"function"},{"doc":"Parses string containing JSON to Toolbox.Scenario.UserAction .","ref":"Toolbox.Scenario.UserAction.html#parse_raw_action/1","title":"Toolbox.Scenario.UserAction.parse_raw_action/1","type":"function"},{"doc":"Fired user action. When action is fired by the user, it should be pushed to raw topic with current timestamp to be correctly reordered by Normalizer . Properties type and details should contain enough information for routing action to the target scenario. Property user is ID of user who fired the action, data contains extra information attached by environment where user fired the action (for example comment filled by the user on UI).","ref":"Toolbox.Scenario.UserAction.html#t:t/0","title":"Toolbox.Scenario.UserAction.t/0","type":"type"},{"doc":"A set of utility functions for Enums.","ref":"Toolbox.Utils.Enum.html","title":"Toolbox.Utils.Enum","type":"module"},{"doc":"Returns :ok if fun applied to every element of enumerable returns :ok . Otherwise it returns the first error occurred during fun call. Example iex&gt; each_while_ok ( [ ] , fn _ -&gt; :not_called_at_all end ) :ok iex&gt; each_while_ok ( [ 1 , 2 , 3 ] , fn _ -&gt; :ok end ) :ok iex&gt; each_while_ok ( [ 1 , 2 , 3 ] , &amp; ( if &amp;1 == 2 , do : { :error , &amp;1 } , else : :ok ) ) { :error , 2 }","ref":"Toolbox.Utils.Enum.html#each_while_ok/2","title":"Toolbox.Utils.Enum.each_while_ok/2","type":"function"},{"doc":"Flattens the enum by the specified amount of levels. Flattens only the specified amount of levels, contrary to the standard List.flatten/2 which flattens the list recursively. Handy if you e.g. want to flatten only the first level. Importantly, this operation maintains order of the elements in the list. Examples iex&gt; flatten_levels ( [ [ :hello , :team ] , [ &quot;this&quot; , &quot;is&quot; ] , [ &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] ] , 1 ) [ :hello , :team , &quot;this&quot; , &quot;is&quot; , &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] iex&gt; flatten_levels ( [ [ :hello , :team ] , [ &quot;this&quot; , &quot;is&quot; ] , [ &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] ] , 2 ) [ :hello , :team , &quot;this&quot; , &quot;is&quot; , &quot;now&quot; , &quot;flat&quot; , [ &quot;list&quot; ] ] iex&gt; flatten_levels ( [ [ :hello , :team ] , [ &quot;this&quot; , &quot;is&quot; ] , [ &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] ] , 3 ) [ :hello , :team , &quot;this&quot; , &quot;is&quot; , &quot;now&quot; , &quot;flat&quot; , &quot;list&quot; ] iex&gt; flatten_levels ( [ [ :hello , :team ] , [ &quot;this&quot; , &quot;is&quot; ] , [ &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] ] , 4 ) [ :hello , :team , &quot;this&quot; , &quot;is&quot; , &quot;now&quot; , &quot;flat&quot; , &quot;list&quot; ] iex&gt; flatten_levels ( [ [ :hello , :team ] , [ &quot;this&quot; , &quot;is&quot; ] , [ &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] ] , 0 ) [ [ :hello , :team ] , [ &quot;this&quot; , &quot;is&quot; ] , [ &quot;now&quot; , [ &quot;flat&quot; , [ &quot;list&quot; ] ] ] ]","ref":"Toolbox.Utils.Enum.html#flatten_levels/2","title":"Toolbox.Utils.Enum.flatten_levels/2","type":"function"},{"doc":"Returns {:ok, list_of_values} if fun applied to every element of enumerable returns {:ok, value} . Otherwise it returns the first error occurred during fun call. Example iex&gt; map_while_ok ( [ ] , fn _ -&gt; :not_called_at_all end ) { :ok , [ ] } iex&gt; map_while_ok ( [ 1 , 2 , 3 ] , &amp; ( { :ok , &amp;1 * 2 } ) ) { :ok , [ 2 , 4 , 6 ] } iex&gt; map_while_ok ( [ 1 , 2 , 3 ] , &amp; ( if &amp;1 == 2 , do : { :error , &amp;1 * 2 } , else : { :ok , &amp;1 * 2 } ) ) { :error , 4 }","ref":"Toolbox.Utils.Enum.html#map_while_ok/2","title":"Toolbox.Utils.Enum.map_while_ok/2","type":"function"},{"doc":"Invokes fun for each element in the enumerable with the accumulator. If every fun call returns {:ok, new_acc} , functions returns {:ok, last_acc} . Otherwise it returns the first error occurred during fun call. Example iex&gt; reduce_while_ok ( [ ] , :initial , fn _ , _ -&gt; :not_called_at_all end ) { :ok , :initial } iex&gt; reduce_while_ok ( [ 1 , 2 , 3 ] , 0 , &amp; ( { :ok , &amp;1 + &amp;2 } ) ) { :ok , 6 } iex&gt; reduce_while_ok ( [ 1 , 2 , 3 ] , 0 , &amp; ( if &amp;1 == 2 , do : { :error , &amp;1 + &amp;2 } , else : { :ok , &amp;1 + &amp;2 } ) ) { :error , 3 }","ref":"Toolbox.Utils.Enum.html#reduce_while_ok/3","title":"Toolbox.Utils.Enum.reduce_while_ok/3","type":"function"},{"doc":"A set of utility functions for Maps.","ref":"Toolbox.Utils.Map.html","title":"Toolbox.Utils.Map","type":"module"},{"doc":"Creates deep map with value on key represented by path . If path is empty, it returns given value . Examples iex&gt; Toolbox.Utils.Map . deep_create ( [ ] , :some_value ) :some_value iex&gt; Toolbox.Utils.Map . deep_create ( [ &quot;a&quot; , :b ] , :other_value ) %{ &quot;a&quot; =&gt; %{ :b =&gt; :other_value } }","ref":"Toolbox.Utils.Map.html#deep_create/2","title":"Toolbox.Utils.Map.deep_create/2","type":"function"},{"doc":"Deeply updates left map by right map. Existing keys from left map not contained in right map are unchanged. New keys from right map are added. If the key is present in both maps and both values are maps, maps are deeply merges. If the key is present in both maps and value of one of them is not a map, value of key in left map is replaced by value in right map. Example iex&gt; Toolbox.Utils.Map . deep_merge ( %{ a : 1 } , %{ b : 2 } ) %{ a : 1 , b : 2 } iex&gt; Toolbox.Utils.Map . deep_merge ( %{ a : %{ b : 1 } } , %{ a : %{ c : 3 } } ) %{ a : %{ b : 1 , c : 3 } } iex&gt; Toolbox.Utils.Map . deep_merge ( %{ a : %{ b : %{ c : 1 } } } , %{ a : %{ b : %{ d : 2 } } } ) %{ a : %{ b : %{ c : 1 , d : 2 } } } iex&gt; Toolbox.Utils.Map . deep_merge ( %{ a : 1 } , %{ a : %{ b : 2 } } ) %{ a : %{ b : 2 } } iex&gt; Toolbox.Utils.Map . deep_merge ( %{ a : %{ b : 1 } } , %{ a : 2 } ) %{ a : 2 } iex&gt; Toolbox.Utils.Map . deep_merge ( %{ a : 1 } , %{ a : 2 } ) %{ a : 2 }","ref":"Toolbox.Utils.Map.html#deep_merge/2","title":"Toolbox.Utils.Map.deep_merge/2","type":"function"},{"doc":"Removes key represented as path (list of keys) deeply in map if it exists. Example iex&gt; Toolbox.Utils.Map . deep_remove ( %{ a : 1 , b : 2 } , [ ] ) %{ a : 1 , b : 2 } iex&gt; Toolbox.Utils.Map . deep_remove ( %{ a : 1 , b : 2 } , [ :a ] ) %{ b : 2 } iex&gt; Toolbox.Utils.Map . deep_remove ( %{ a : 1 , b : 2 } , [ :a , :aa ] ) %{ a : 1 , b : 2 } iex&gt; Toolbox.Utils.Map . deep_remove ( %{ a : %{ aa : 1 , ab : 2 } , b : 2 } , [ :a , :aa ] ) %{ a : %{ ab : 2 } , b : 2 } iex&gt; Toolbox.Utils.Map . deep_remove ( %{ a : %{ aa : 1 , ab : 2 } , b : 2 } , [ :a , :aa , :aaa ] ) %{ a : %{ aa : 1 , ab : 2 } , b : 2 }","ref":"Toolbox.Utils.Map.html#deep_remove/2","title":"Toolbox.Utils.Map.deep_remove/2","type":"function"},{"doc":"Converts map from flat to nested map. The input map must be flat with array keys, which represent the path to the respective values. The corresponding nested map is then constructed. Also see to_flat_map/1 which performs the reverse operation. Examples iex&gt; Toolbox.Utils.Map . from_flat_map ( %{ ...&gt; [ &quot;contact&quot; , &quot;name&quot; ] =&gt; &quot;Jored&quot; , ...&gt; [ &quot;contact&quot; , &quot;address&quot; , &quot;city&quot; ] =&gt; &quot;Lrno&quot; , ...&gt; [ &quot;active&quot; , &quot;ui&quot; ] =&gt; true , ...&gt; [ &quot;active&quot; , &quot;backend&quot; ] =&gt; false ...&gt; } ) %{ &quot;contact&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Jored&quot; , &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;Lrno&quot; } } , &quot;active&quot; =&gt; %{ &quot;ui&quot; =&gt; true , &quot;backend&quot; =&gt; false } } iex&gt; Toolbox.Utils.Map . from_flat_map ( %{ ...&gt; [ :very , :very , :very , :very , :very , :very , :deep ] =&gt; &quot;object&quot; , ...&gt; [ :very , :very , :very , :very , :very , :very , :nested ] =&gt; &quot;map&quot; ...&gt; } ) %{ very : %{ very : %{ very : %{ very : %{ very : %{ very : %{ deep : &quot;object&quot; , nested : &quot;map&quot; } } } } } } } iex&gt; Toolbox.Utils.Map . from_flat_map ( %{ } ) %{ } iex&gt; Toolbox.Utils.Map . from_flat_map ( Toolbox.Utils.Map . to_flat_map ( %{ ...&gt; &quot;contact&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Jonas&quot; , ...&gt; &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;Brnp&quot; } } , ...&gt; &quot;favorites&quot; =&gt; %{ ...&gt; &quot;food&quot; =&gt; %{ ...&gt; 1 =&gt; [ &quot;cornflakes&quot; , &quot;corn&quot; ] , ...&gt; 5 =&gt; [ &quot;pizza&quot; ] , ...&gt; 8 =&gt; [ &quot;pasta&quot; ] ...&gt; } ...&gt; } ...&gt; } ...&gt; ) ) %{ &quot;contact&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Jonas&quot; , &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;Brnp&quot; } } , &quot;favorites&quot; =&gt; %{ &quot;food&quot; =&gt; %{ 1 =&gt; [ &quot;cornflakes&quot; , &quot;corn&quot; ] , 5 =&gt; [ &quot;pizza&quot; ] , 8 =&gt; [ &quot;pasta&quot; ] } } }","ref":"Toolbox.Utils.Map.html#from_flat_map/1","title":"Toolbox.Utils.Map.from_flat_map/1","type":"function"},{"doc":"Follows the path in the (deep) map, defaulting to default if some of the objects on the path is missing. Example iex&gt; object = %{ &quot;some&quot; =&gt; %{ &quot;deep&quot; =&gt; %{ &quot;object&quot; =&gt; &quot;data&quot; } } } ...&gt; Toolbox.Utils.Map . get_path ( object , [ &quot;some&quot; , &quot;deep&quot; , &quot;object&quot; ] ) &quot;data&quot; iex&gt; Toolbox.Utils.Map . get_path ( object , [ &quot;non-existent&quot; ] , &quot;default&quot; ) &quot;default&quot;","ref":"Toolbox.Utils.Map.html#get_path/3","title":"Toolbox.Utils.Map.get_path/3","type":"function"},{"doc":"Extracts all (json-like) paths in the map. Given any artitrarily nested map, the function returns all paths the map contains. The output is not sorted in a predictable way. Examples iex&gt; Toolbox.Utils.Map . json_paths ( %{ ...&gt; &quot;contact&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Trest&quot; , ...&gt; &quot;phone&quot; =&gt; 605554171 , ...&gt; &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;Brno&quot; } ...&gt; } , ...&gt; &quot;active&quot; =&gt; false ...&gt; } ) |&gt; Enum . sort ( ) [ [ &quot;active&quot; ] , [ &quot;contact&quot; , &quot;address&quot; , &quot;city&quot; ] , [ &quot;contact&quot; , &quot;name&quot; ] , [ &quot;contact&quot; , &quot;phone&quot; ] , ] iex&gt; Toolbox.Utils.Map . json_paths ( %{ &quot;a&quot; =&gt; %{ 1 =&gt; %{ %{ &quot;cool&quot; =&gt; &quot;stuff&quot; } =&gt; %{ atom : :work_too } } } } ) [ [ &quot;a&quot; , 1 , %{ &quot;cool&quot; =&gt; &quot;stuff&quot; } , :atom ] ] iex&gt; Toolbox.Utils.Map . json_paths ( %{ } ) [ ]","ref":"Toolbox.Utils.Map.html#json_paths/1","title":"Toolbox.Utils.Map.json_paths/1","type":"function"},{"doc":"Subtracts map from another map, the leaf-paths from the second map are removed from the first. Examples iex&gt; Toolbox.Utils.Map . subtract ( %{ a : 1 , b : 2 } , %{ a : true } ) %{ b : 2 } iex&gt; Toolbox.Utils.Map . subtract ( %{ a : 1 } , %{ a : %{ b : %{ c : true } } } ) %{ a : 1 } iex&gt; Toolbox.Utils.Map . subtract ( ...&gt; %{ a : %{ b : %{ c : &quot;1&quot; } , d : &quot;2&quot; } , e : &quot;3&quot; } , ...&gt; %{ a : %{ b : %{ c : true } } , e : true } ...&gt; ) %{ a : %{ b : %{ } , d : &quot;2&quot; } } iex&gt; Toolbox.Utils.Map . subtract ( ...&gt; %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; %{ &quot;c&quot; =&gt; true } } , ...&gt; %{ &quot;b&quot; =&gt; %{ &quot;c&quot; =&gt; true } } ...&gt; ) %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; %{ } } iex&gt; Toolbox.Utils.Map . subtract ( %{ a : 1 , b : 2 } , %{ c : 2 , d : 3 } ) %{ a : 1 , b : 2 } iex&gt; Toolbox.Utils.Map . subtract ( %{ a : %{ b : 1 } } , %{ a : true } ) %{ }","ref":"Toolbox.Utils.Map.html#subtract/2","title":"Toolbox.Utils.Map.subtract/2","type":"function"},{"doc":"Converts regular nested map to flat map. The input map can be any map - arbitrarily nested, the output is a flat map where keys are arrays representing the path to the respective value. Also see from_flat_map/1 which performs the reverse operation. Examples iex&gt; Toolbox.Utils.Map . to_flat_map ( %{ ...&gt; &quot;contact&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;Kert&quot; , ...&gt; &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;Krno&quot; } ...&gt; } , ...&gt; &quot;status&quot; =&gt; %{ &quot;ui&quot; =&gt; %{ &quot;active&quot; =&gt; true } , ...&gt; &quot;backend&quot; =&gt; %{ &quot;fluent&quot; =&gt; false } } ...&gt; } ) %{ [ &quot;contact&quot; , &quot;name&quot; ] =&gt; &quot;Kert&quot; , [ &quot;contact&quot; , &quot;address&quot; , &quot;city&quot; ] =&gt; &quot;Krno&quot; , [ &quot;status&quot; , &quot;ui&quot; , &quot;active&quot; ] =&gt; true , [ &quot;status&quot; , &quot;backend&quot; , &quot;fluent&quot; ] =&gt; false } iex&gt; Toolbox.Utils.Map . to_flat_map ( %{ good : %{ 1 =&gt; :nice } , very : %{ deep : %{ %{ ish : :map } =&gt; :askey } } } ) %{ [ :good , 1 ] =&gt; :nice , [ :very , :deep , %{ ish : :map } ] =&gt; :askey } iex&gt; Toolbox.Utils.Map . to_flat_map ( %{ &quot;regular&quot; =&gt; &quot;map&quot; } ) %{ [ &quot;regular&quot; ] =&gt; &quot;map&quot; } iex&gt; Toolbox.Utils.Map . to_flat_map ( %{ } ) %{ }","ref":"Toolbox.Utils.Map.html#to_flat_map/1","title":"Toolbox.Utils.Map.to_flat_map/1","type":"function"},{"doc":"Utilities for handling configured paths.","ref":"Toolbox.Utils.Path.html","title":"Toolbox.Utils.Path","type":"module"},{"doc":"Gets the Altworx root dir.","ref":"Toolbox.Utils.Path.html#get_altworx_root/0","title":"Toolbox.Utils.Path.get_altworx_root/0","type":"function"},{"doc":"Resolves a possibly relative path to absolute path by prepending the Altworx root dir (see set_altworx_root/1 ). Examples iex&gt; Path . set_altworx_root ( &quot;/opt/altworx&quot; ) :ok iex&gt; Path . resolve_path ( &quot;/already/absolute/path&quot; ) &quot;/already/absolute/path&quot; iex&gt; Path . resolve_path ( &quot;some/../relative/path&quot; ) &quot;/opt/altworx/relative/path&quot;","ref":"Toolbox.Utils.Path.html#resolve_path/1","title":"Toolbox.Utils.Path.resolve_path/1","type":"function"},{"doc":"Sets where the Altworx root dir is. Configuration and data dirs are supposed to be relative to the root dir. It is typically the directory which the VM is started in.","ref":"Toolbox.Utils.Path.html#set_altworx_root/1","title":"Toolbox.Utils.Path.set_altworx_root/1","type":"function"},{"doc":"Module provides API to define state machine based workflow. Workflow is represented by struct containing all configuration needed to handle state of individual instances of given workflow. Workflow is defined by transitions, which contains all needed attributes (source node, target node, ..). Workflow defined by transitions needs to be built epxlicitly by calling build/1 function. This function validates all workflow dependencies and state machine structure. Workflow definition produced by build/1 function can be used to create new instance of given workflow. Workflow instance is struct of: unique id status state (map containing all relevant data, manipulated by then callback during status transition) history (record of all transitions which given instance went through in the past) history in default is map of %{&quot;timestamp&quot; =&gt; timestamp, &quot;status&quot; =&gt; binary} history entry can be updated via update_history_entry callback defined in transition possible transitions (list of all transitions which could be executed in close future) possible transition in default is map of %{&quot;timestamp&quot; =&gt; -1 | timestamp, &quot;status&quot; =&gt; binary} timestamp -1 represents non-timeoutable transition possible transition entry can be updated via update_possible_transition callback defined in transition Workflow transition can be defined by: from (source status) to (target status) when (predicate used to select transition which will be executed) there can be multiple when definitions in list, all definitions are connected with &amp;&amp; relation possible when definitions: {Module, function} , where function accepts transition, instance and message as args {:timeout, timeout} , where timeout is defined in milliseconds {:=, [path, to, state, key], value} {:&gt;, [path, to, state, key], value} {:&lt;, [path, to, state, key], value} {:&lt;=, [path, to, state, key], value} {:&gt;=, [path, to, state, key], value} {:contains, [path, to, state, key], value} {:is_in, [path, to, state, key], list_value} all callbacks should return boolean value then (callback used to update workflow instance state during transition execution) there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts transition, instance and message as args all calbacks should return {:ok, %{} = wf_instance_state} | {:error, reason} side_effects (callback used to generate output actions during transition execution) there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts transition, instance and message as args all calbacks should return {:ok, [OutputAction]} | {:error, reason} update_history_entry (callback used to modify transition execution history entry) there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts history entry, transition, instance and message as args all calbacks should return {:ok, %{} = updated_history_entry} | {:error, reason} update_possible_transition (callback used in handle_message/3 to modify possible transition) there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts possible transtion, transition, instance and message as args all calbacks should return {:ok, %{} = updated_possible_transition} | {:error, reason} Workflow transition execution uses given workflow definition and message to update state of given instance. If no configured workflow transition matches, nothing will happend = instance state will remain the same. Order of callback execution: when definitions of transitions in definition order then definitions of matching transition update history entry definitions of matching transition update possible transition definitions of matching transition side effects definitions of matching transition","ref":"Toolbox.Workflow.html","title":"Toolbox.Workflow","type":"module"},{"doc":"Workflow transition can be defined by keys in params: from (source status) required parameter to (target status) required parameter when (predicate used to select transition which will be executed) optional parameter there can be multiple when definitions in list, all definitions are connected with &amp;&amp; relation possible when definitions: {Module, function} , where function accepts transition, instance and message as args {:timeout, timeout} , where timeout is defined in milliseconds {:=, [path, to, state, key], value} {:&gt;, [path, to, state, key], value} {:&lt;, [path, to, state, key], value} {:&lt;=, [path, to, state, key], value} {:&gt;=, [path, to, state, key], value} {:contains, [path, to, state, key], value} {:is_in, [path, to, state, key], list_value} all callbacks should return boolean value then (callback used to update workflow instance state during transition execution) optional parameter there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts transition, instance and message as args all calbacks should return {:ok, %{} = wf_instance_state} | {:error, reason} side_effects (callback used to generate output actions during transition execution) optional parameter there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts transition, instance and message as args all calbacks should return {:ok, [OutputAction]} | {:error, reason} update_history_entry (callback used to modify transition execution history entry) optional parameter there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts history entry, transition, instance and message as args all calbacks should return {:ok, %{} = updated_history_entry} | {:error, reason} update_possible_transition (callback used in handle_message/3 to modify possible transition) optional parameter there can be multiple then definitions in list, all definitions are executed in given order possible then definitions: {Module, function} , where funciton accepts possible transtion, transition, instance and message as args all calbacks should return {:ok, %{} = updated_possible_transition} | {:error, reason}","ref":"Toolbox.Workflow.html#add_transition/2","title":"Toolbox.Workflow.add_transition/2","type":"function"},{"doc":"Finishes workflow definition, validates all configured dependencies and workflow structure","ref":"Toolbox.Workflow.html#build/1","title":"Toolbox.Workflow.build/1","type":"function"},{"doc":"Uses given workflow definition and message to update state of given instance. If no configured workflow transition matches, nothing will happend = instance state will remain the same. Order of callback execution: when definitions of transitions in definition order then definitions of matching transition update history entry definitions of matching transition update possible transition definitions of matching transition side effects definitions of matching transition","ref":"Toolbox.Workflow.html#handle_message/2","title":"Toolbox.Workflow.handle_message/2","type":"function"},{"doc":"","ref":"Toolbox.Workflow.html#handle_message/3","title":"Toolbox.Workflow.handle_message/3","type":"function"},{"doc":"Creates new blank workflow definition","ref":"Toolbox.Workflow.html#new/0","title":"Toolbox.Workflow.new/0","type":"function"},{"doc":"Creates new instance for given workflow","ref":"Toolbox.Workflow.html#new_instance/6","title":"Toolbox.Workflow.new_instance/6","type":"function"},{"doc":"","ref":"Toolbox.Workflow.html#t:status/0","title":"Toolbox.Workflow.status/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.html#t:t/0","title":"Toolbox.Workflow.t/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.html#t:transitions/0","title":"Toolbox.Workflow.transitions/0","type":"type"},{"doc":"Workflow instance is simple struct which keeps state if individual workflow instances. Workflow updates its status/state via defined callbacks during workflow transitions.","ref":"Toolbox.Workflow.Instance.html","title":"Toolbox.Workflow.Instance","type":"module"},{"doc":"","ref":"Toolbox.Workflow.Instance.html#t:t/0","title":"Toolbox.Workflow.Instance.t/0","type":"type"},{"doc":"Transitions forms workflow configuration. Struct is used internally - workflow client should not know internal details about transition struct.","ref":"Toolbox.Workflow.Transition.html","title":"Toolbox.Workflow.Transition","type":"module"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:builtin_when_fn_def/0","title":"Toolbox.Workflow.Transition.builtin_when_fn_def/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:side_effects_fn_def/0","title":"Toolbox.Workflow.Transition.side_effects_fn_def/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:t/0","title":"Toolbox.Workflow.Transition.t/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:then_fn_def/0","title":"Toolbox.Workflow.Transition.then_fn_def/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:update_history_entry_fn_def/0","title":"Toolbox.Workflow.Transition.update_history_entry_fn_def/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:update_possible_transition_fn_def/0","title":"Toolbox.Workflow.Transition.update_possible_transition_fn_def/0","type":"type"},{"doc":"","ref":"Toolbox.Workflow.Transition.html#t:when_fn_def/0","title":"Toolbox.Workflow.Transition.when_fn_def/0","type":"type"}]